****************************************************************************************************			
* Pantalla "std" 	$0c00-$23ff - SAM offset = $0c00 / $200 =  6 = #%0000110 - valor por defecto
* buffer				$2400-3bff	- SAM offset = $2400 / $200 = 18 = #%0010010
****************************************************************************************************			
			opt	cd
			org	$4500					; donde ubicar el programa
inicio	orcc	#$50					; deshabilita interrupciones
			lda	#$5					; poner a uno los bits 0 y 2
			sta	$ff03					; para detectar FS al final de pantalla

			ldx	#$0c00				; origen de pantalla (inicial donde est imagen a mover)
			stx	origen				; guardar puntero
			ldy	#$2400				; destino sin desplazar
			sty	destino				; guardar puntero
			ldb	#192					; filas a desplazar para mover toda la pantalla
			stb	<$76					; guardar en variable pagina 0
L1			lda	#191					; numero de lineas a hacer scroll (la ltima NO)
			sta	<$77					; guardar en variable pagina 0
			ldu	<$8a					; tomar doble cero
			stu	,y++					; 2
			stu	,y++					; 4
			stu	,y++					; 6
			stu	,y++					; 8 
			stu	,y++					;10
			stu	,y++					;12
			stu	,y++					;14
			stu	,y++					;16
			stu	,y++					;18
			stu	,y++					;20
			stu	,y++					;22
			stu	,y++					;24
			stu	,y++					;26
			stu	,y++					;28
			stu	,y++					;30
			stu	,y++					; limpiar los 32 bytes de la primera linea

m1L		ldu	,x++
			stu	,y++					;  2 bytes copiados
			ldu	,x++
			stu	,y++					;  4 bytes copiados
			ldu	,x++
			stu	,y++					;  6 bytes copiados
			ldu	,x++
			stu	,y++					;  8 bytes copiados
			ldu	,x++
			stu	,y++					; 10 bytes copiados
			ldu	,x++
			stu	,y++					; 12 bytes copiados
			ldu	,x++
			stu	,y++					; 14 bytes copiados
			ldu	,x++
			stu	,y++					; 16 bytes copiados
			ldu	,x++
			stu	,y++					; 18 bytes copiados
			ldu	,x++
			stu	,y++					; 20 bytes copiados
			ldu	,x++
			stu	,y++					; 22 bytes copiados
			ldu	,x++
			stu	,y++					; 24 bytes copiados
			ldu	,x++
			stu	,y++					; 26 bytes copiados
			ldu	,x++
			stu	,y++					; 28 bytes copiados
			ldu	,x++
			stu	,y++					; 30 bytes copiados
			ldu	,x++
			stu	,y++					; 32 bytes copiados = 1 linea completa
			dec 	<$77					; movidas todas las lneas?
			bne	m1L					; no, hacer siguiente lnea

eHs		lda	$ff03					; lleg interrupcin HSYNC? (la de final de pantalla!)
			bpl	eHs					; esperar
			lda	$ff02					; limpiar indicador de interrupcin
											; cambiar inicio de pantalla en SAM
cambio	lda	<$76					; lee contador numero de scrolls a realizar (+1)
			anda	#1						; usa bit cero
			beq	par					; si es par mostrar buffer
											; si es impar mostrar 'std'
impar		sta	$ffc6					; 0
			sta	$ffc9					; 1
			sta	$ffcb					; 1
			sta	$ffcc					; 0
			sta	$ffce					; 0
			sta	$ffd0					; 0
			sta	$ffd2					; 0  = #%0000110 = 6 (valor x defecto)
			bra	actPun				; salta codigo para Pares
par		sta	$ffc6					; 0
			sta	$ffc9					; 1
			sta	$ffca					; 0
			sta	$ffcc					; 0
			sta	$ffcf					; 1
			sta	$ffd0					; 0
			sta	$ffd2					; 0  = #%0010010 = 18 (valor x buffer)
											; cambiar punteros
actPun	ldx	destino				; toma destino (nuevo origen)
			ldy	origen				; toma origen (nuevo destino)
			sty	destino				; actualiza destino actual
			stx	origen				; actualiza origen actual
			dec	<$76					; movida la imagen completa?
			lbne	L1						; no, siguiente pixel abajo
			andcc	#$af					; habilita interrupciones
			rts							; retorna
****************************************************************************************************
origen	fdb	$0000
destino	fdb	$0000
			end 	inicio
